// perf_tst.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    return TRUE;
}

#include <cmath>     // math functions.

#ifndef PI 
#define PI 3.141592653589793238462643 
#endif

double __stdcall pdfN(double x) 
// normal probability density function = exp(-x^2) * 1/sqrt(2*Pi)
{  
return ( exp(-x*x*0.5) * 0.3989422804014326779399462);
};

double __stdcall cdfN_simple(double x) 
// cumulative univariate normal distribution, 
// Abramowitz & Stegun 26.2.17
{
	double a,t,taylor,out;
	double b1 =  0.31938153; 
	double b2 = -0.356563782; 
	double b3 =  1.781477937;
	double b4 = -1.821255978;
	double b5 =  1.330274429; 
	double p  =  0.2316419; 
		
	//if (x < -6.0) { return 0.0; };
	//if (6.0 < x ) { return 1.0; };
	
	a=fabs(x); 
	t = 1.0/(1.0+a*p); 
	taylor = ((((b5*t+b4)*t+b3)*t+b2)*t+b1)*t; 
	out = 1.0 - pdfN(x)*taylor; 
	if ( x < 0.0 ) out = 1.0 - out; 
	return out; 
}

double __stdcall bsc(double S, double K, double t, double r, double v)
// BS call: spot, strike, time, rates, vola
{ 
	double sigma, d1, d2;

	sigma = v*sqrt(t);
	d1 = (log(S/K)+r*t)/sigma + 0.5*sigma; 
	d2 = d1 - sigma;
	return ( S * cdfN_simple(d1) - K * exp(-r*t) * cdfN_simple(d2) );
};

double __stdcall bsc_testsum(double S, double K, double t, double r, double v, 
														 long nSteps)
// sum up from K to K+1 over a grid of 1/nSteps
{ 
	double sum;
	long i,imax;
	
	imax = nSteps;
	sum = 0.0;
	for(i=0; i<=imax; i++)
		{
			sum +=bsc(S,K + i/imax,t,r,v);
		};
	return sum;
};
